<div class="datePick">
  <div class="selectDate" (click)="showDatePicker = !showDatePicker">
    <div>{{ monthNames[selectedmonth] }}, {{ yearMonth }}</div>
    <i
      class="fa icon-arrow-down fa-lg customfilter"
      style="font-size: 10px"
    ></i>
  </div>
  <div
    class="e-header-calendar e-control e-lib e-calendar e-keyboard datePickContainer"
    data-role="calendar"
    tabindex="0"
    *ngIf="showDatePicker"
  >
    <div class="e-header e-year">
      <div
        class="e-day e-title"
        aria-atomic="true"
        aria-live="assertive"
        aria-label="title"
      >
        {{ selectedYeaur }}
      </div>
      <div class="e-icon-container">
        <button
          class="e-prev"
          type="button"
          data-ripple="true"
          aria-disabled="false"
          aria-label="previous month"
          (click)="selectedYeaur = selectedYeaur + 1"
        >
          <i class="fa icon-arrow-up fa-lg customfilter"></i></button
        ><button
          class="e-next"
          type="button"
          data-ripple="true"
          aria-disabled="false"
          aria-label="next month"
          (click)="selectedYeaur = selectedYeaur - 1"
        >
          <i class="fa icon-arrow-down fa-lg customfilter"></i>
        </button>
      </div>
    </div>
    <div class="e-content e-year">
      <table tabindex="0" role="grid" aria-activedescendant="1612134000000_274">
        <tbody class="">
          <tr role="row">
            <td
              class="e-cell"
              [class.e-selected]="selectedmonth === 0"
              (click)="changeMonth(0)"
              [class.e-selected-year]="
                selectedmonth === 0 && selectedYeaur != yearMonth
              "
              id="1609455600000_273"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Janv</span>
            </td>
            <td
              class="e-cell"
              [class.e-selected]="selectedmonth === 1"
              (click)="changeMonth(1)"
              [class.e-selected-year]="
                selectedmonth === 1 && selectedYeaur != yearMonth
              "
              id="1612134000000_274"
              aria-selected="true"
              role="gridcell"
              aria-label="February 2021"
            >
              <span class="e-day" data-ripple="true">Févr</span>
            </td>
            <td
              [class.e-selected]="selectedmonth === 2"
              (click)="changeMonth(2)"
              [class.e-selected-year]="
                selectedmonth === 2 && selectedYeaur != yearMonth
              "
              class="e-cell"
              id="1614553200000_275"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Mars</span>
            </td>
            <td
              [class.e-selected]="selectedmonth === 3"
              (click)="changeMonth(3)"
              [class.e-selected-year]="
                selectedmonth === 3 && selectedYeaur != yearMonth
              "
              class="e-cell"
              id="1617231600000_276"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Avr</span>
            </td>
          </tr>
          <tr role="row">
            <td
              [class.e-selected]="selectedmonth === 4"
              (click)="changeMonth(4)"
              [class.e-selected-year]="
                selectedmonth === 4 && selectedYeaur != yearMonth
              "
              class="e-cell"
              id="1619823600000_277"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Mai</span>
            </td>
            <td
              [class.e-selected]="selectedmonth === 5"
              (click)="changeMonth(5)"
              [class.e-selected-year]="
                selectedmonth === 5 && selectedYeaur != yearMonth
              "
              class="e-cell"
              id="1622502000000_278"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Jun</span>
            </td>
            <td
              [class.e-selected]="selectedmonth == 6"
              (click)="changeMonth(6)"
              [class.e-selected-year]="
                selectedmonth === 6 && selectedYeaur != yearMonth
              "
              class="e-cell"
              id="1625094000000_279"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Juil</span>
            </td>
            <td
              [class.e-selected]="selectedmonth === 7"
              (click)="changeMonth(7)"
              [class.e-selected-year]="
                selectedmonth === 7 && selectedYeaur != yearMonth
              "
              class="e-cell"
              id="1627772400000_280"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Août</span>
            </td>
          </tr>
          <tr role="row">
            <td
              [class.e-selected]="selectedmonth === 8"
              (click)="changeMonth(8)"
              [class.e-selected-year]="
                selectedmonth === 8 && selectedYeaur != yearMonth
              "
              class="e-cell"
              id="1630450800000_281"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Sept</span>
            </td>
            <td
              [class.e-selected]="selectedmonth === 9"
              (click)="changeMonth(9)"
              [class.e-selected-year]="
                selectedmonth === 9 && selectedYeaur != yearMonth
              "
              class="e-cell"
              id="1633042800000_282"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Oct</span>
            </td>
            <td
              [class.e-selected]="selectedmonth === 10"
              (click)="changeMonth(10)"
              [class.e-selected-year]="
                selectedmonth === 10 && selectedYeaur != yearMonth
              "
              class="e-cell"
              id="1635721200000_283"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Nov</span>
            </td>
            <td
              [class.e-selected]="selectedmonth === 11"
              (click)="changeMonth(11)"
              [class.e-selected-year]="
                selectedmonth === 11 && selectedYeaur != yearMonth
              "
              class="e-cell"
              id="1638313200000_284"
              aria-selected="false"
              role="gridcell"
            >
              <span class="e-day" data-ripple="true">Déc</span>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <div class="e-footer-container">
      <button
        role="button"
        data-ripple="true"
        aria-label="Today"
        class="e-btn e-today e-flat e-primary e-css"
        (click)="aujourdhui()"
      >
        Aujourd'hui
      </button>
    </div>
  </div>
</div>

<div class="materialTable">
  <div class="loadingTableContainer" *ngIf="isLoading || dataNotFound">
    <div class="loadingTable">
      <div class="dataNotFound" *ngIf="isLoading">
        <div style="opacity: 1; color: black">Chargement ...</div>
        <img src="assets/img/gif/cloud.gif" alt="this scope moves" width="80" />
      </div>
      <div class="dataNotFound" *ngIf="dataNotFound">
        <div style="color: black">Aucune donnée trouvée !</div>
        <img src="assets/img/gif/zoom.gif" alt="this scope moves" width="50" />
      </div>
    </div>
  </div>

  <div class="leftTable">
    <table
      class="table table-bordered"
      style="width: 200px; background-color: #eaeaea"
    >
      <thead style="background-color: rgb(60, 126, 87)">
        <tr
          style="
            height: 96px;
            background-color: rgb(60, 126, 87);
            border-color: rgb(60, 126, 87);
            color: rgb(60, 126, 87);
          "
        >
          .
        </tr>
      </thead>
      <tbody>
        <tr style="height: 46px" *ngFor="let product of products">
          <td>
            <div
              style="
                display: flex;
                justify-content: center;
                align-items: center;
                height: 20.41px;
              "
            >
              {{ product.serialNumber }} - {{ product.model }}
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
  <div style="width: 100%">
    <div class="monthHead">
      <div class="flechContainer" (click)="changeMonth(selectedmonth - 1)">
        <i class="fa icon-arrow-left fa-lg customfilter"></i>
      </div>
      <div>{{ monthNames[selectedmonth] }}, {{ yearMonth }}</div>
      <div class="flechContainer" (click)="changeMonth(selectedmonth + 1)">
        <i class="fa icon-arrow-right fa-lg customfilter"></i>
      </div>
    </div>
    <div class="tableContainer">
      <table class="table table-bordered" >
      <thead style="background-color:  rgb(60, 126, 87);">
      <tr>
        <th *ngFor="let day of dayList">
          <div class="colonneCalendar">
            <div>
              {{day[0].slice(0,3)}}
            </div>
            <div>
              {{day[1]}}
            </div>
          </div>
        </th>
      </tr>
    </thead>
    <tbody>
      <tr style="height: 46px" *ngFor="let rev of listReserv; let i=index">
        <td
          (click)="reservation(i,j,cel.idRev);myModal.show()"
          [colSpan]="cel.colspan"
          class="caseTable" *ngFor="let cel of rev;let j=index"
        >
          <div
            [class.reserve]="cel.reserve"
            [class.contrat]="cel.status=='Contrat'"
          >{{cel.client}}</div>
        </td>
      </tr>
    </tbody>
  </table>
    </div>
  </div>
</div>
<div
  bsModal
  #myModal="bs-modal"
  class="modal fade"
  tabindex="-1"
  role="dialog"
  aria-labelledby="myModalLabel"
  aria-hidden="false"
>
  <div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">Réservation</h4>
        <button
          type="button"
          class="close"
          (click)="myModal.hide(); addForm = myForm; resetAddModal()"
          aria-label="Close"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div role="alert" class="alert alert-success" *ngIf="successAddSiteType">
        Un nouveau type de site est ajouté <strong>avec succès.</strong>
      </div>
      <div role="alert" class="alert alert-danger" *ngIf="errorAddSiteType">
        <strong>Oops! </strong> Modifiez quelques éléments et essayez de
        soumettre de nouveau !
      </div>
      <form #myForm="ngForm">
        <div class="modal-body">
          <div class="form-group custom-col">
            <label
              style="
                display: flex;
                justify-content: space-between;
                padding-right: 20px;
              "
            >
              Client
              <div
                *ngIf="ReservContrat == false"
                (click)="this.getClients(); myClientModal.show()"
                style="
                  color: #4a148c;
                  cursor: pointer;
                  font-size: 13px;
                  text-decoration: underline;
                "
              >
                Selectioner un client
              </div>
            </label>
            <div class="clientContainer">
              <div [class.grise]="ReservContrat" class="clientName">
                {{ clientName }}
              </div>
              <i
                *ngIf="ReservContrat == false"
                (click)="effacerClient()"
                class="fa icon-close fa-lg customfilter"
                style="
                  font-size: 20px;
                  color: white;
                  background-color: red;
                  padding: 0;
                  border-radius: 50%;
                  margin: 0px 5px;
                  cursor: pointer;
                "
              ></i>
            </div>
          </div>
          <div class="form-group custom-col">
            <label>Status</label>
            <select
              [disabled]="ReservContrat"
              type="text"
              placeholder="Nom de type.."
              class="form-control"
              [(ngModel)]="newReparation.status"
              style="color: black"
              name="status"
              required
              #status="ngModel"
            >
              <option selected value="">Choisir un status</option>
              <option value="Réservation">Réservation</option>
              <option value="Contrat" [disabled]="!enableContrat">
                Contrat
              </option>
            </select>
            <span *ngIf="!status.valid && status.touched">
              <div *ngIf="status.errors.required">
                * Ce champ est obligatoire !
              </div>
            </span>
          </div>
          <div class="form-group custom-col">
            <label>Date de debut</label>
            <input
              [disabled]="ReservContrat"
              (change)="changeDateDebut()"
              type="date"
              placeholder="Nom de type.."
              class="form-control"
              [(ngModel)]="newReparation.startDate"
              style="color: black"
              name="startDate"
              required
              #startDate="ngModel"
            />
            <span *ngIf="!startDate.valid && startDate.touched">
              <div *ngIf="startDate.errors.required">
                * Ce champ est obligatoire !
              </div>
            </span>
          </div>
          <div class="form-group custom-col">
            <label>Date de fin</label>
            <input
              [disabled]="ReservContrat"
              (change)="refrechDate()"
              [min]="newReparation.startDate"
              type="date"
              placeholder="Nom de type.."
              class="form-control"
              [(ngModel)]="newReparation.endDate"
              style="color: black"
              name="endDate"
              required
              #endDate="ngModel"
            />
            <span *ngIf="!endDate.valid && endDate.touched">
              <div *ngIf="endDate.errors.required">
                * Ce champ est obligatoire !
              </div>
            </span>
          </div>
          <div class="form-group custom-col" style="margin-bottom: 0px">
            <label>Produit</label>
          </div>
          <div class="form-group custom-col" style="margin-bottom: 0px">
            <label>Montant</label>
          </div>
          <div
            class="productsSelect"
            *ngFor="let x of productsReserv; let i = index"
          >
            <div class="form-group custom-col">
              <select
                [disabled]="ReservContrat"
                style="color: black"
                class="form-control"
                [(ngModel)]="newReparation.products[i]"
                [ngModelOptions]="{ standalone: true }"
                (change)="confirmProd($event, i)"
              >
                <option selected value="a">Choisir un produit</option>
                <option
                  *ngFor="let rentalType of products"
                  [ngValue]="rentalType['@id']"
                  [tabIndex]=""
                >
                  <div>{{ rentalType["model"] }}</div>
                </option>
              </select>
            </div>
            <div class="form-group custom-col montantContainer">
              <div class="montantMat">
                <div *ngIf="productsReserv[i]['price'] > 0">
                  {{ productsReserv[i]["price"] }} €
                </div>
              </div>
              <div
                *ngIf="ReservContrat == false"
                (click)="delProd(i)"
                class="retirer"
              >
                -
              </div>
              <div
                *ngIf="i == productsReserv.length - 1 && ReservContrat == false"
                class="retirer"
                style="
                  background-color: green;
                  font-size: 30px;
                  font-weight: bold;
                  padding-bottom: 9px;
                "
                (click)="addProd(i)"
              >
                +
              </div>
            </div>
          </div>
          <div class="footerTotal">
            <div class="QuntJour">
              <div class="Quantite">
                <label> Quantité </label>
                <div
                  class="clientName"
                  style="cursor: auto; background-color: #e4e7ea"
                >
                  {{ this.newReparation.products.length }}
                </div>
              </div>
              <div class="Quantite">
                <label> Nbre Jour </label>
                <div
                  class="clientName"
                  style="cursor: auto; background-color: #e4e7ea"
                >
                  {{ diffDate }}
                </div>
              </div>
            </div>
            <div class="tableTotal">
              <table class="table table-bordered table-striped">
                <tbody>
                  <tr>
                    <td class="colTot">Une journée</td>
                    <td class="colTot">{{ totalPriceDay }} €</td>
                  </tr>
                  <tr>
                    <td class="colTot">Total</td>
                    <td class="colTot">{{ totalPriceDay * diffDate }} €</td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>
        </div>
        <div
          *ngIf="ReservContrat == false"
          class="modal-footer"
          style="
            display: flex;
            width: 100%;
            padding-left: 40px;
            justify-content: flex-end;
          "
        >
          <button
            *ngIf="idRev"
            type="button"
            class="btn btn-danger"
            style="color: white"
            (click)="
              deleteRev(); myModal.hide(); addForm = myForm; resetAddModal()
            "
          >
            Supprimer
          </button>
          <div style="width: 60%"></div>
          <div>
            <button
              type="button"
              class="btn btn-secondary"
              (click)="myModal.hide(); addForm = myForm; resetAddModal()"
            >
              Annuler
            </button>
            <button
              [disabled]="myForm.form.invalid || clientName == ''"
              type="button"
              class="btn addButton"
              (click)="
                ajouterReserv();
                myModal.hide();
                addForm = myForm;
                resetAddModal()
              "
            >
              Enregistrer
            </button>
          </div>
        </div>
      </form>
    </div>
    <!-- /.modal-content -->
  </div>
  <!-- /.modal-dialog -->
</div>
<div
  style="margin-top: 70px"
  bsModal
  #myClientModal="bs-modal"
  class="modal fade"
  tabindex="-1"
  role="dialog"
  aria-labelledby="myModalLabel"
  aria-hidden="false"
>
  <div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">Sélectionner un client</h4>
        <button
          type="button"
          class="close"
          (click)="
            myClientModal.hide();
            addFormClent = myClientForm;
            resetAddModalClent()
          "
          aria-label="Close"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div role="alert" class="alert alert-success" *ngIf="successAddSiteType">
        Un nouveau type de site est ajouté <strong>avec succès.</strong>
      </div>
      <div role="alert" class="alert alert-danger" *ngIf="errorAddSiteType">
        <strong>Oops! </strong> Modifiez quelques éléments et essayez de
        soumettre de nouveau !
      </div>
      <form #myClientForm="ngForm">
        <div class="modal-body">
          <div
            style="
              width: 100%;
              display: flex;
              justify-content: flex-end;
              padding-right: 10%;
            "
          >
            <div style="margin-right: 5px">Ajouter un client</div>
            <label class="switch switch-label switch-pill switch-success">
              <input
                type="checkbox"
                [(ngModel)]="showAddFormClient"
                (click)="changeStatut()"
                name="add"
                #add="ngModel"
                class="switch-input"
              />
              <span
                data-checked="✓"
                data-unchecked="✕"
                class="switch-slider"
              ></span>
            </label>
          </div>
          <div *ngIf="showAddFormClient == true" class="form-group custom-col">
            <label>Prènom</label>
            <input
              type="text"
              placeholder="Prènom.."
              class="form-control"
              [(ngModel)]="client.firstName"
              style="color: black"
              name="prenom"
              required
              #prenom="ngModel"
            />
            <span *ngIf="!prenom.valid && prenom.touched">
              <div *ngIf="prenom.errors.required">
                * Ce champ est obligatoire !
              </div>
            </span>
          </div>
          <div *ngIf="showAddFormClient == true" class="form-group custom-col">
            <label>Nom</label>
            <input
              type="text"
              placeholder="Nom.."
              class="form-control"
              [(ngModel)]="client.lastName"
              style="color: black"
              name="nom"
              required
              #nom="ngModel"
            />
            <span *ngIf="!nom.valid && nom.touched">
              <div *ngIf="nom.errors.required">
                * Ce champ est obligatoire !
              </div>
            </span>
          </div>
          <div *ngIf="showAddFormClient == true" class="form-group custom-col">
            <label>Email</label>
            <input
              type="text"
              placeholder="Prènom.."
              class="form-control"
              [(ngModel)]="client.email"
              style="color: black"
              name="email"
              required
              #email="ngModel"
            />
            <span *ngIf="!email.valid && email.touched">
              <div *ngIf="email.errors.required">
                * Ce champ est obligatoire !
              </div>
            </span>
          </div>
          <div *ngIf="showAddFormClient == true" class="form-group custom-col">
            <label>Pays</label>
            <select
              style="color: black"
              class="form-control"
              [(ngModel)]="client.country"
              name="pays"
              required
              #pays="ngModel"
            >
              <option selected value="">Choisir une pays</option>
              <option
                *ngFor="let rentalType of listPays"
                [ngValue]="rentalType"
              >
                {{ rentalType }}
              </option>
            </select>
            <span *ngIf="!pays.valid && pays.touched">
              <div *ngIf="pays.errors.required">
                * Ce champ est obligatoire !
              </div>
            </span>
          </div>
          <div *ngIf="showAddFormClient == true" class="form-group custom-col">
            <label>Region</label>
            <select
              style="color: black"
              class="form-control"
              [(ngModel)]="client.town"
              name="region"
              required
              #region="ngModel"
            >
              <option selected value="">Choisir une region</option>
              <option
                *ngFor="let rentalType of listRegion"
                [ngValue]="rentalType"
              >
                {{ rentalType }}
              </option>
            </select>
            <span *ngIf="!region.valid && region.touched">
              <div *ngIf="region.errors.required">
                * Ce champ est obligatoire !
              </div>
            </span>
          </div>

          <div
            *ngIf="showAddFormClient == true"
            class="form-group custom-col"
          ></div>
          <div
            *ngIf="showAddFormClient == true"
            style="
              width: 100%;
              display: flex;
              justify-content: flex-end;
              padding-right: 20%;
              margin-bottom: 20px;
            "
          >
            <button
              [disabled]="myClientForm.form.invalid"
              type="button"
              class="btn addButton"
              (click)="
                ajouterClient();
                myClientModal.hide();
                addFormClent = myClientForm;
                resetAddModalClent()
              "
            >
              Enregistrer
            </button>
          </div>
          <div class="form-group custom-col" style="width: 40%">
            <label>Prènom</label>
            <input
              type="text"
              placeholder="Prènom.."
              class="form-control"
              [(ngModel)]="filterPrenom"
              style="color: black"
              [ngModelOptions]="{ standalone: true }"
            />
          </div>
          <div class="form-group custom-col" style="width: 40%">
            <label>Nom</label>
            <input
              type="text"
              placeholder="Nom.."
              class="form-control"
              [(ngModel)]="filterNom"
              style="color: black"
              [ngModelOptions]="{ standalone: true }"
            />
          </div>
          <div
            class="form-group custom-col"
            style="width: 20%; display: flex; align-items: flex-end"
          >
            <button
              [disabled]="filterNom == '' && filterPrenom == ''"
              type="button"
              class="btn addButton"
              (click)="filterClients()"
            >
              Rechercher
            </button>
          </div>
          <div class="card" style="width: 100%">
            <div class="card-body">
              <div
                class="loadingTableContainer"
                *ngIf="isLoading || dataNotFound"
              >
                <div class="loadingTable">
                  <div class="dataNotFound" *ngIf="isLoading">
                    <div style="opacity: 0.7; color: black">Chargement ...</div>
                    <img
                      src="../../../assets/img/gif/cloud.gif"
                      alt="this scope moves"
                      width="70"
                    />
                  </div>
                  <div class="dataNotFound" *ngIf="dataNotFound">
                    <div style="color: black">Aucune donnée trouvée !</div>
                    <img
                      src="../../../assets/img/gif/zoom.gif"
                      alt="this scope moves"
                      width="50"
                    />
                  </div>
                </div>
              </div>
              <table class="table table-striped">
                <thead style="z-index: 88" class="tableHead">
                  <tr class="table-sm cc">
                    <th style="min-width: 80px">Prénom</th>
                    <th style="min-width: 80px">Nom</th>
                    <th style="min-width: 80px">Email</th>
                    <th style="min-width: 80px">Pays</th>
                    <th style="min-width: 80px">Region</th>
                  </tr>
                </thead>
                <tbody>
                  <tr
                    style="cursor: pointer"
                    (click)="selectClient(usr); myClientModal.hide()"
                    *ngFor="let usr of clients"
                  >
                    <td>{{ usr.firstName }}</td>
                    <td>{{ usr.lastName }}</td>
                    <td>{{ usr.Email }}</td>
                    <td>{{ usr.country }}</td>
                    <td>{{ usr.town }}</td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>
        </div>
      </form>
    </div>
    <!-- /.modal-content -->
  </div>
  <!-- /.modal-dialog -->
</div>
